## kwin 5.15.11.65

=== effects/CMakeLists.txt ===
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_OFF")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")
endif()
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kwin_effects\" -DEFFECT_BUILTINS)

include_directories(${KWIN_SOURCE_DIR}) # for xcbutils.h
pkg_search_module(QGSETTINGS REQUIRED IMPORTED_TARGET gsettings-qt)

find_package(Qt5LinguistTools REQUIRED)

set(kwin_effect_OWN_LIBS
    kwineffects
)

if( KWIN_HAVE_XRENDER_COMPOSITING )
    set(kwin_effect_OWN_LIBS ${kwin_effect_OWN_LIBS} kwinxrenderutils)
endif()

set(kwin_effect_KDE_LIBS
    KF5::ConfigGui
    KF5::ConfigWidgets
    KF5::GlobalAccel
    KF5::I18n
    KF5::WindowSystem
    KF5::Plasma # screenedge effect
    KF5::IconThemes
    KF5::Service
    KF5::Notifications # screenshot effect
)

set(kwin_effect_QT_LIBS
    Qt5::Concurrent
    Qt5::DBus
    Qt5::Quick
    Qt5::X11Extras
    PkgConfig::QGSETTINGS
)

set(kwin_effect_XLIB_LIBS
    ${X11_X11_LIB}
)

set(kwin_effect_XCB_LIBS
    XCB::XCB
    XCB::IMAGE
    XCB::XFIXES
)

if( KWIN_HAVE_XRENDER_COMPOSITING )
    set(kwin_effect_XCB_LIBS ${kwin_effect_XCB_LIBS} XCB::RENDER)
endif()

set(kwin_effect_OWN_LIBS ${kwin_effect_OWN_LIBS} kwinglutils)

macro( KWIN4_ADD_EFFECT_BACKEND name )
    add_library( ${name} SHARED ${ARGN} )
    target_link_libraries( ${name} PRIVATE ${kwin_effect_OWN_LIBS} ${kwin_effect_KDE_LIBS} ${kwin_effect_QT_LIBS} ${kwin_effect_XLIB_LIBS} ${kwin_effect_XCB_LIBS} libdl.so)
endmacro()

# Adds effect plugin with given name. Sources are given after the name
macro( KWIN4_ADD_EFFECT name )
    kwin4_add_effect_backend(kwin4_effect_${name} ${ARGN})

    set_target_properties(kwin4_effect_${name} PROPERTIES VERSION 1.0.0 SOVERSION 1 )
    set_target_properties(kwin4_effect_${name} PROPERTIES OUTPUT_NAME ${KWIN_NAME}4_effect_${name})
    install(TARGETS kwin4_effect_${name} ${INSTALL_TARGETS_DEFAULT_ARGS} )

endmacro()

# translations
file(GLOB TS LIST_DIRECTORIES false multitaskview/translations/multitasking*.ts)
foreach(_ts_file ${TS})
    execute_process(
        COMMAND ${LUPDATE_EXECUTABLE} -recursive ${CMAKE_SOURCE_DIR}/translations -ts ${_ts_file})
    execute_process(COMMAND lrelease ${_ts_file})
endforeach()

# Install the KWin/Effect service type
install( FILES kwineffect.desktop DESTINATION ${SERVICETYPES_INSTALL_DIR} )

# Create initial variables
set( kwin4_effect_include_directories )

set( kwin4_effect_builtins_sources
    logging.cpp
    effect_builtins.cpp
    blur/blur.cpp
    blur/blurshader.cpp
    colorpicker/colorpicker.cpp
    cube/cube.cpp
    cube/cube_proxy.cpp
    cubeslide/cubeslide.cpp
    coverswitch/coverswitch.cpp
    desktopgrid/desktopgrid.cpp
    diminactive/diminactive.cpp
    flipswitch/flipswitch.cpp
    glide/glide.cpp
    invert/invert.cpp
    lookingglass/lookingglass.cpp
    magiclamp/magiclamp.cpp
    magnifier/magnifier.cpp
    mouseclick/mouseclick.cpp
    mousemark/mousemark.cpp
    presentwindows/presentwindows.cpp
    presentwindows/presentwindows_proxy.cpp
    resize/resize.cpp
    showfps/showfps.cpp
    showpaint/showpaint.cpp
    slide/slide.cpp
    thumbnailaside/thumbnailaside.cpp
    touchpoints/touchpoints.cpp
    trackmouse/trackmouse.cpp
    windowgeometry/windowgeometry.cpp
    wobblywindows/wobblywindows.cpp
    zoom/zoom.cpp
    splitscreen/splitscreen.cpp
    splithandler/splithandler.cpp
    multitaskview/multitaskview.cpp
    ../report.cpp
    )

qt5_add_resources( kwin4_effect_builtins_sources shaders.qrc )

kconfig_add_kcfg_files(kwin4_effect_builtins_sources
    blur/blurconfig.kcfgc
    cube/cubeconfig.kcfgc
    cubeslide/cubeslideconfig.kcfgc
    coverswitch/coverswitchconfig.kcfgc
    desktopgrid/desktopgridconfig.kcfgc
    diminactive/diminactiveconfig.kcfgc
    fallapart/fallapartconfig.kcfgc
    flipswitch/flipswitchconfig.kcfgc
    glide/glideconfig.kcfgc
    lookingglass/lookingglassconfig.kcfgc
    magiclamp/magiclampconfig.kcfgc
    magnifier/magnifierconfig.kcfgc
    mouseclick/mouseclickconfig.kcfgc
    mousemark/mousemarkconfig.kcfgc
    presentwindows/presentwindowsconfig.kcfgc
    resize/resizeconfig.kcfgc
    showfps/showfpsconfig.kcfgc
    slide/slideconfig.kcfgc
    slidingpopups/slidingpopupsconfig.kcfgc
    thumbnailaside/thumbnailasideconfig.kcfgc
    trackmouse/trackmouseconfig.kcfgc
    windowgeometry/windowgeometryconfig.kcfgc
    wobblywindows/wobblywindowsconfig.kcfgc
    zoom/zoomconfig.kcfgc
    )

# scripted effects
add_subdirectory( dialogparent )
add_subdirectory( dimscreen )
add_subdirectory( eyeonscreen )
add_subdirectory( fade )
add_subdirectory( fadedesktop )
add_subdirectory( fadingpopups )
add_subdirectory( frozenapp )
add_subdirectory( login )
add_subdirectory( logout )
add_subdirectory( maximize )
add_subdirectory( morphingpopups )
add_subdirectory( scale )
add_subdirectory( squash )
add_subdirectory( translucency )
add_subdirectory( windowaperture )

###############################################################################
# Built-in effects go here

# Common effects
add_subdirectory( desktopgrid )
add_subdirectory( diminactive )
include( fallapart/CMakeLists.txt )
include( highlightwindow/CMakeLists.txt )
include( kscreen/CMakeLists.txt )
add_subdirectory( magiclamp )
add_subdirectory( presentwindows )
add_subdirectory( resize )
include( screenedge/CMakeLists.txt )
add_subdirectory( showfps )
add_subdirectory( showpaint )
add_subdirectory( slide )
include( slideback/CMakeLists.txt )
include( slidingpopups/CMakeLists.txt )
add_subdirectory( thumbnailaside )
add_subdirectory( windowgeometry )
add_subdirectory( zoom )
add_subdirectory( splitscreen )
add_subdirectory( splithandler )
add_subdirectory( multitaskview )

# OpenGL-specific effects
add_subdirectory( blur )
include( backgroundcontrast/CMakeLists.txt )
add_subdirectory( coverswitch )
add_subdirectory( cube )
add_subdirectory( cubeslide )
add_subdirectory( flipswitch )
add_subdirectory( glide )
add_subdirectory( invert )
add_subdirectory( lookingglass )
add_subdirectory( magnifier )
add_subdirectory( mouseclick )
add_subdirectory( mousemark )
include( screenshot/CMakeLists.txt )
include( sheet/CMakeLists.txt )
include( snaphelper/CMakeLists.txt )
include( startupfeedback/CMakeLists.txt )
add_subdirectory( trackmouse )
add_subdirectory( wobblywindows )

###############################################################################

# Add the builtins plugin
kwin4_add_effect( builtins ${kwin4_effect_builtins_sources} )

=== libkwineffects/CMakeLists.txt ===
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_OFF")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")
endif()
########### next target ###############
include(ECMSetupVersion)

ecm_setup_version(${PROJECT_VERSION}
                  VARIABLE_PREFIX KWINEFFECTS
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kwineffects_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KWinEffectsConfigVersion.cmake"
                  SOVERSION 12
)

### xrenderutils lib ###
set(kwin_XRENDERUTILS_SRCS
    kwinxrenderutils.cpp
    logging.cpp
    )

add_library(kwinxrenderutils SHARED ${kwin_XRENDERUTILS_SRCS})
generate_export_header(kwinxrenderutils EXPORT_FILE_NAME kwinxrenderutils_export.h)
target_link_libraries(kwinxrenderutils
    PUBLIC
        Qt5::Core
        Qt5::Gui
        XCB::XCB
        XCB::XFIXES
        XCB::RENDER
        KF5::WaylandServer
    )

set_target_properties(kwinxrenderutils PROPERTIES
    VERSION ${KWINEFFECTS_VERSION_STRING}
    SOVERSION ${KWINEFFECTS_SOVERSION}
)
set_target_properties(kwinxrenderutils PROPERTIES OUTPUT_NAME ${KWIN_NAME}xrenderutils)

install(TARGETS kwinxrenderutils EXPORT kdeworkspaceLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

###  effects lib  ###
set(kwin_EFFECTSLIB_SRCS
    kwineffects.cpp
    kwineffectsex.cpp
    anidata.cpp
    kwinanimationeffect.cpp
    logging.cpp
    )

set(kwineffects_QT_LIBS
    Qt5::DBus
    Qt5::Widgets
)

set(kwineffects_KDE_LIBS
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::WindowSystem
)

set(kwineffects_XCB_LIBS
    XCB::XCB
)

add_library(kwineffects SHARED ${kwin_EFFECTSLIB_SRCS})
generate_export_header(kwineffects EXPORT_FILE_NAME kwineffects_export.h)
target_link_libraries(kwineffects
PUBLIC
    ${kwineffects_QT_LIBS}
    ${kwineffects_KDE_LIBS}
    ${kwineffects_XCB_LIBS}
)
if( KWIN_HAVE_XRENDER_COMPOSITING )
    target_link_libraries(kwineffects PRIVATE kwinxrenderutils XCB::XFIXES)
endif()
set_target_properties(kwineffects PROPERTIES
    VERSION ${KWINEFFECTS_VERSION_STRING}
    SOVERSION ${KWINEFFECTS_SOVERSION}
)
set_target_properties(kwineffects PROPERTIES OUTPUT_NAME ${KWIN_NAME}effects)

install(TARGETS kwineffects EXPORT kdeworkspaceLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

# kwingl(es)utils library
set(kwin_GLUTILSLIB_SRCS
    kwinglutils.cpp
    kwingltexture.cpp
    kwinglutils_funcs.cpp
    kwinglplatform.cpp
    kwineglimagetexture.cpp
    logging.cpp
    )

macro( KWIN4_ADD_GLUTILS_BACKEND name glinclude )
    include_directories(${glinclude})
    add_library(${name} SHARED ${kwin_GLUTILSLIB_SRCS})
    generate_export_header(${name} BASE_NAME kwinglutils EXPORT_FILE_NAME kwinglutils_export.h)
    target_link_libraries(${name} PUBLIC XCB::XCB KF5::CoreAddons KF5::ConfigCore KF5::WindowSystem)
    set_target_properties(${name} PROPERTIES
        VERSION ${KWINEFFECTS_VERSION_STRING}
        SOVERSION ${KWINEFFECTS_SOVERSION}
    )
    target_link_libraries(${name} PUBLIC ${ARGN})

    install(TARGETS ${name} EXPORT kdeworkspaceLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS})
endmacro()

kwin4_add_glutils_backend(kwinglutils ${epoxy_INCLUDE_DIR} ${epoxy_LIBRARY})
set_target_properties(kwinglutils PROPERTIES OUTPUT_NAME ${KWIN_NAME}glutils)

target_link_libraries(kwinglutils PUBLIC ${epoxy_LIBRARY})

install( FILES
    kwinglobals.h
    kwineffects.h
    kwineffectsex.h
    kwinanimationeffect.h
    kwinglplatform.h
    kwinglutils.h
    kwinglutils_funcs.h
    kwingltexture.h
    kwinxrenderutils.h
    ${CMAKE_CURRENT_BINARY_DIR}/kwinconfig.h
    ${CMAKE_CURRENT_BINARY_DIR}/kwineffects_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/kwinglutils_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/kwinxrenderutils_export.h
    DESTINATION ${INCLUDE_INSTALL_DIR} COMPONENT Devel)

=== autotests/drm/CMakeLists.txt ===
#set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
#set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")

include_directories(${Libdrm_INCLUDE_DIRS} ../)

set(mockDRM_SRCS
    mock_drm.cpp
    ../../plugins/platforms/drm/drm_buffer.cpp
    ../../plugins/platforms/drm/drm_object.cpp
    ../../plugins/platforms/drm/drm_object_connector.cpp
    ../../plugins/platforms/drm/drm_object_plane.cpp
    ../../plugins/platforms/drm/logging.cpp
)

add_library(mockDrm STATIC ${mockDRM_SRCS})
target_link_libraries(mockDrm Qt5::Gui)
ecm_mark_as_test(mockDrm)

function(drmTest)
    set(oneValueArgs NAME)
    set(multiValueArgs SRCS )
    cmake_parse_arguments(ARGS "" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    add_executable(${ARGS_NAME} ${ARGS_SRCS} ../testprintasanbase.cpp)
    target_link_libraries(${ARGS_NAME} mockDrm Qt5::Test)
    add_test(NAME kwin-drm-${ARGS_NAME} COMMAND ${ARGS_NAME})
    ecm_mark_as_test(${ARGS_NAME})
endfunction()

drmTest(NAME objecttest SRCS objecttest.cpp)

=== autotests/libkwineffects/CMakeLists.txt ===
#message(STATUS "TTTTTTTTTTTTTT : ${CMAKE_SAFETYTEST}")
#message(STATUS "VVVVVVVVVVVVVV : ${CMAKE_CXX_FLAGS}")

include(ECMMarkAsTest)
include_directories(../)

macro(KWINEFFECTS_UNIT_TESTS)
   foreach(_testname ${ARGN})
      add_executable(${_testname} ${_testname}.cpp ../testprintasanbase.cpp)
      add_test(NAME kwineffects-${_testname} COMMAND ${_testname})
      target_link_libraries(${_testname} Qt5::Test kwineffects)
      ecm_mark_as_test(${_testname})
   endforeach()
endmacro()

kwineffects_unit_tests(
    windowquadlisttest
    timelinetest
)

add_executable(kwinglplatformtest kwinglplatformtest.cpp mock_gl.cpp ../../libkwineffects/kwinglplatform.cpp ../testprintasanbase.cpp)
add_test(NAME kwineffects-kwinglplatformtest COMMAND kwinglplatformtest)
target_link_libraries(kwinglplatformtest Qt5::Test Qt5::Gui Qt5::X11Extras KF5::ConfigCore XCB::XCB)
ecm_mark_as_test(kwinglplatformtest)

=== autotests/tabbox/CMakeLists.txt ===
#set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
#set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")

include_directories(${KWIN_SOURCE_DIR} ../)
add_definitions(-DKWIN_UNIT_TEST)
########################################################
# Test TabBox::ClientModel
########################################################
set( testTabBoxClientModel_SRCS
     ../../tabbox/clientmodel.cpp
     ../../tabbox/desktopmodel.cpp
     ../../tabbox/tabboxconfig.cpp
     ../../tabbox/tabboxhandler.cpp
     ../../tabbox/tabbox_logging.cpp
     test_tabbox_clientmodel.cpp
     mock_tabboxhandler.cpp
     mock_tabboxclient.cpp
      ../testprintasanbase.cpp
)

add_executable( testTabBoxClientModel ${testTabBoxClientModel_SRCS} )
set_target_properties(testTabBoxClientModel PROPERTIES COMPILE_DEFINITIONS "NO_NONE_WINDOW")
target_link_libraries( testTabBoxClientModel
    Qt5::Core
    Qt5::Widgets
    Qt5::Script
    Qt5::Quick
    Qt5::Test
    Qt5::X11Extras
    KF5::ConfigCore
    KF5::I18n
    KF5::Package
    KF5::WindowSystem
    XCB::XCB
)
add_test(NAME kwin-testTabBoxClientModel COMMAND testTabBoxClientModel)
ecm_mark_as_test(testTabBoxClientModel)

########################################################
# Test TabBox::TabBoxHandler
########################################################
set( testTabBoxHandler_SRCS
     ../../tabbox/clientmodel.cpp
     ../../tabbox/desktopmodel.cpp
     ../../tabbox/tabboxconfig.cpp
     ../../tabbox/tabboxhandler.cpp
     ../../tabbox/tabbox_logging.cpp
     test_tabbox_handler.cpp
     mock_tabboxhandler.cpp
     mock_tabboxclient.cpp
      ../testprintasanbase.cpp
)

add_executable( testTabBoxHandler ${testTabBoxHandler_SRCS} )
set_target_properties(testTabBoxHandler PROPERTIES COMPILE_DEFINITIONS "NO_NONE_WINDOW")
target_link_libraries( testTabBoxHandler
    Qt5::Core
    Qt5::Widgets
    Qt5::Script
    Qt5::Quick
    Qt5::Test
    Qt5::X11Extras
    KF5::ConfigCore
    KF5::I18n
    KF5::Package
    KF5::WindowSystem
    XCB::XCB
)
add_test(NAME kwin-testTabBoxHandler COMMAND testTabBoxHandler)
ecm_mark_as_test(testTabBoxHandler)

########################################################
# Test TabBox::TabBoxConfig
########################################################
set( testTabBoxConfig_SRCS
    ../../tabbox/tabboxconfig.cpp
    ../../tabbox/tabbox_logging.cpp
    test_tabbox_config.cpp
     ../testprintasanbase.cpp
)

add_executable( testTabBoxConfig ${testTabBoxConfig_SRCS} )
target_link_libraries( testTabBoxConfig Qt5::Core Qt5::Test )
add_test(NAME kwin-testTabBoxConfig COMMAND testTabBoxConfig)
ecm_mark_as_test(testTabBoxConfig)


########################################################
# Test TabBox::DesktopChainManager
########################################################
set( testDesktopChain_SRCS
    ../../tabbox/desktopchain.cpp
    ../../tabbox/tabbox_logging.cpp
    test_desktopchain.cpp
     ../testprintasanbase.cpp
)

add_executable( testDesktopChain ${testDesktopChain_SRCS} )
target_link_libraries( testDesktopChain Qt5::Core Qt5::Test )
add_test(NAME kwin-testDesktopChain COMMAND testDesktopChain)
ecm_mark_as_test(testDesktopChain)

=== effects/cube/CMakeLists.txt ===
#######################################
# Effect

# Data files
install( FILES
    data/cubecap.png
    DESTINATION ${DATA_INSTALL_DIR}/kwin )

#######################################
# Config

set(kwin_cube_config_SRCS cube_config.cpp)
ki18n_wrap_ui(kwin_cube_config_SRCS cube_config.ui)
qt5_add_dbus_interface(kwin_cube_config_SRCS ${kwin_effects_dbus_xml} kwineffects_interface)
kconfig_add_kcfg_files(kwin_cube_config_SRCS cubeconfig.kcfgc)

add_library(kwin_cube_config MODULE ${kwin_cube_config_SRCS})

target_link_libraries(kwin_cube_config
    KF5::ConfigWidgets
    KF5::GlobalAccel
    KF5::I18n
    KF5::XmlGui
    KF5::KIOWidgets
    KF5::Service
)

kcoreaddons_desktop_to_json(kwin_cube_config cube_config.desktop SERVICE_TYPES kcmodule.desktop)

install(
    TARGETS
        kwin_cube_config
    DESTINATION
        ${PLUGIN_INSTALL_DIR}/kwin/effects/configs
)

=== effects/lookingglass/CMakeLists.txt ===
#######################################
# Effect

#######################################
# Config
set(kwin_lookingglass_config_SRCS lookingglass_config.cpp)
ki18n_wrap_ui(kwin_lookingglass_config_SRCS lookingglass_config.ui)
qt5_add_dbus_interface(kwin_lookingglass_config_SRCS ${kwin_effects_dbus_xml} kwineffects_interface)
kconfig_add_kcfg_files(kwin_lookingglass_config_SRCS lookingglassconfig.kcfgc)

add_library(kwin_lookingglass_config MODULE ${kwin_lookingglass_config_SRCS})

target_link_libraries(kwin_lookingglass_config
    KF5::ConfigWidgets
    KF5::GlobalAccel
    KF5::I18n
    KF5::Service
    KF5::XmlGui
)

kcoreaddons_desktop_to_json(kwin_lookingglass_config lookingglass_config.desktop SERVICE_TYPES kcmodule.desktop)

install(
    TARGETS
        kwin_lookingglass_config
    DESTINATION
        ${PLUGIN_INSTALL_DIR}/kwin/effects/configs
)

=== effects/multitaskview/CMakeLists.txt ===
#######################################
# Effect

# Source files
set( kwin4_effect_builtins_sources ${kwin4_effect_builtins_sources}
    multitaskview/multitaskview.cpp
    )

=== kcmkwin/kwincompositing/CMakeLists.txt ===
#########################################################################
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcmkwincompositing\")

add_definitions(-DQT_NO_URL_CAST_FROM_STRING)

remove_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_STRICT_ITERATORS -DQT_NO_CAST_FROM_BYTEARRAY)

include_directories(${KWIN_SOURCE_DIR}/effects)

################# configure checks and create the configured files #################

# now create config headers
configure_file(config-prefix.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-prefix.h )
configure_file(config-compiler.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-compiler.h )

set(kwincomposing_SRC
    model.cpp
    main.cpp
    compositing.cpp
    effectconfig.cpp)

qt5_add_dbus_interface( kwincomposing_SRC
  ${KWIN_SOURCE_DIR}/org.kde.kwin.Compositing.xml kwin_compositing_interface)
qt5_add_dbus_interface( kwincomposing_SRC
  ${KWIN_SOURCE_DIR}/org.kde.kwin.Effects.xml kwin_effects_interface)

ki18n_wrap_ui(kwincomposing_SRC compositing.ui)

add_library(kwincompositing MODULE ${kwincomposing_SRC})

target_link_libraries(kwincompositing
    Qt5::Quick
    Qt5::QuickWidgets
    Qt5::DBus
    Qt5::Widgets
    KF5::CoreAddons
    KF5::ConfigCore
    KF5::Declarative
    KF5::I18n
    KF5::KCMUtils
    KF5::NewStuff
    kcmkwincommon
)

if (BUILD_TESTING)
    include(ECMMarkAsTest)

    set(modelTest_SRC
        model.cpp
        effectconfig.cpp
        compositing.cpp
        test/effectmodeltest.cpp
        test/modeltest.cpp)

    qt5_add_dbus_interface(modelTest_SRC
        ${KWIN_SOURCE_DIR}/org.kde.kwin.Compositing.xml kwin_compositing_interface)
    qt5_add_dbus_interface(modelTest_SRC
        ${KWIN_SOURCE_DIR}/org.kde.kwin.Effects.xml kwin_effects_interface)

    add_executable(effectModelTest ${modelTest_SRC})
    ecm_mark_as_test(effectModelTest)

    target_link_libraries(effectModelTest
        Qt5::Quick
        Qt5::QuickWidgets
        Qt5::DBus
        Qt5::Test
        Qt5::Widgets
        KF5::CoreAddons
        KF5::ConfigCore
        KF5::Declarative
        KF5::I18n
        KF5::KCMUtils
        KF5::NewStuff
        kwineffects
        kcmkwincommon
    )
endif()

INSTALL(DIRECTORY qml DESTINATION ${DATA_INSTALL_DIR}/kwincompositing)
INSTALL(TARGETS kwincompositing DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES kwincompositing.desktop kcmkwineffects.desktop  DESTINATION  ${SERVICES_INSTALL_DIR})
install(FILES kwineffect.knsrc DESTINATION ${CONFIG_INSTALL_DIR})
################# list the subdirectories #################

=== packageplugins/scripts/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kwin_package_scripts\")

set(scripts_SRCS
    scripts.cpp
)

add_library(kwin_packagestructure_scripts MODULE ${scripts_SRCS})

target_link_libraries(kwin_packagestructure_scripts
   KF5::I18n
   KF5::Package
)

kcoreaddons_desktop_to_json(kwin_packagestructure_scripts kwin-packagestructure-scripts.desktop)

install(TARGETS kwin_packagestructure_scripts DESTINATION ${KDE_INSTALL_PLUGINDIR}/kpackage/packagestructure)

=== autotests/integration/effects/CMakeLists.txt ===
if (XCB_ICCCM_FOUND)
    integrationTest(NAME testTranslucency SRCS translucency_test.cpp LIBS XCB::ICCCM)
    integrationTest(NAME testSlidingPopups SRCS slidingpopups_test.cpp LIBS XCB::ICCCM)
    integrationTest(NAME testShadeWobblyWindows SRCS wobbly_shade_test.cpp LIBS XCB::ICCCM)
endif()
integrationTest(NAME testFade SRCS fade_test.cpp)
integrationTest(WAYLAND_ONLY NAME testEffectWindowGeometry SRCS windowgeometry_test.cpp)
integrationTest(NAME testScriptedEffects SRCS scripted_effects_test.cpp)
integrationTest(WAYLAND_ONLY NAME testToplevelOpenCloseAnimation SRCS toplevel_open_close_animation_test.cpp)
integrationTest(WAYLAND_ONLY NAME testPopupOpenCloseAnimation SRCS popup_open_close_animation_test.cpp)

=== effects/frozenapp/package/CMakeLists.txt ===
install(DIRECTORY contents DESTINATION ${DATA_INSTALL_DIR}/${KWIN_NAME}/effects/kwin4_effect_frozenapp)
install(FILES metadata.desktop DESTINATION ${DATA_INSTALL_DIR}/${KWIN_NAME}/effects/kwin4_effect_frozenapp)

install(FILES metadata.desktop
        DESTINATION ${SERVICES_INSTALL_DIR}/${KWIN_NAME}
        RENAME kwin4_effect_frozenapp.desktop)

file(COPY contents metadata.desktop DESTINATION ${CMAKE_BINARY_DIR}/bin/kwin/effects/kwin4_effect_frozenapp)

=== debian/changelog ===
kwin (4:5.15.11.65-1) unstable; urgency=medium

  * update

 -- Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Mon, 21 Nov 2022 11:02:28 +0800

=== debian/tests/control ===
Tests: testsuite
Depends: @, debhelper, cmake,
         xvfb, xauth, dbus (>= 1.8), xserver-xephyr, libkf5service-bin, kded5,
         xwayland, oxygen-icon-theme, mesa-utils,
         breeze, dmz-cursor-theme
Restrictions: build-needed, allow-stderr

Tests: acc
Depends: @, dh-acc, exuberant-ctags
Restrictions: allow-stderr

## kwin 5.16.5

=== debian/changelog ===
kwin (4:5.16.5-0ubuntu1) eoan; urgency=medium

  * New upstream release (5.16.5)

 -- Rik Mills <rikmills@kubuntu.org>  Wed, 04 Sep 2019 09:24:33 +0100

kwin (4:5.16.4-0ubuntu1) eoan; urgency=medium

  * New upstream release (5.16.4)

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 30 Jul 2019 18:45:21 +0100

kwin (4:5.16.3-0ubuntu2) eoan; urgency=medium

  * No-change rebuild against qtbase-abi-5-12-4.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Fri, 12 Jul 2019 11:18:55 +0300

kwin (4:5.16.3-0ubuntu1) eoan; urgency=medium

  * New upstream release (5.16.3)

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 09 Jul 2019 22:22:39 +0100

kwin (4:5.16.2-0ubuntu1) eoan; urgency=medium

  * New upstream release (5.16.2)

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 25 Jun 2019 18:23:38 +0100

kwin (4:5.16.1-0ubuntu1) eoan; urgency=medium

  * New upstream release (5.16.1)

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 18 Jun 2019 22:24:09 +0100

kwin (4:5.16.0-0ubuntu1) eoan; urgency=medium

  * Move knsrc files to /usr/share/knsrcfiles/ and add maintscript to
    remove from /etc/xdg/.
  * New upstream release (5.16.0)

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 11 Jun 2019 11:36:18 +0100

kwin (4:5.15.90-0ubuntu1) eoan; urgency=medium

  * New build depend on libxcb-util-dev.
  * Update install files.
  * Update & refresh patches.
  * New upstream (beta) release (5.15.90)

 -- Rik Mills <rikmills@kubuntu.org>  Sat, 18 May 2019 08:49:26 +0100

kwin (4:5.15.5-0ubuntu1) eoan; urgency=medium

  * New upstream release (5.15.5)

 -- Rik Mills <rikmills@kubuntu.org>  Fri, 10 May 2019 13:48:18 +0100

=== debian/control ===
Source: kwin
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends: breeze-dev (>= 4:5.16.5~),
               cmake (>= 3.1~),
               debhelper (>= 11~),
               extra-cmake-modules (>= 5.58.0~),
               kinit-dev (>= 5.58.0~),
               kscreenlocker-dev (>= 5.16.5~),
               libcap-dev [linux-any],
               libdrm-dev (>= 2.4.62~),
               libegl1-mesa-dev (>= 1.2~),
               libepoxy-dev (>= 1.2),
               libfontconfig1-dev,
               libfreetype6-dev,
               libgbm-dev,
               libice-dev,
               libinput-dev (>= 1.9~),
               libkdecorations2-dev (>= 4:5.16.5~),
               libkf5activities-dev (>= 5.58.0~),
               libkf5completion-dev (>= 5.58.0~),
               libkf5config-dev (>= 5.58.0~),
               libkf5configwidgets-dev (>= 5.58.0~),
               libkf5coreaddons-dev (>= 5.58.0~),
               libkf5crash-dev (>= 5.58.0~),
               libkf5declarative-dev (>= 5.58.0~),
               libkf5doctools-dev (>= 5.58.0~),
               libkf5globalaccel-dev (>= 5.58.0~),
               libkf5i18n-dev (>= 5.58.0~),
               libkf5iconthemes-dev (>= 5.58.0~),
               libkf5idletime-dev (>= 5.58.0~),
               libkf5kcmutils-dev (>= 5.58.0~),
               libkf5kio-dev (>= 5.58.0~),
               libkf5newstuff-dev (>= 5.58.0~),
               libkf5notifications-dev (>= 5.58.0~),
               libkf5package-dev (>= 5.58.0~),
               libkf5plasma-dev (>= 5.58.0~),
               libkf5service-dev (>= 5.58.0~),
               libkf5textwidgets-dev (>= 5.58.0~),
               libkf5wayland-dev (>= 4:5.58.0~),
               libkf5widgetsaddons-dev (>= 5.58.0~),
               libkf5windowsystem-dev (>= 5.58.0~),
               libkf5xmlgui-dev (>= 5.58.0~),
               libqt5sensors5-dev (>= 5.9.0~),
               libqt5x11extras5-dev (>= 5.9.0~),
               libsm-dev,
               libudev-dev [linux-any],
               libwayland-dev (>= 1.2),
               libx11-xcb-dev,
               libxcb-composite0-dev (>= 1.10~),
               libxcb-cursor-dev,
               libxcb-damage0-dev (>= 1.10~),
               libxcb-glx0-dev (>= 1.10~),
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev (>= 1.10~),
               libxcb-render0-dev (>= 1.10~),
               libxcb-shape0-dev (>= 1.10~),
               libxcb-shm0-dev (>= 1.10~),
               libxcb-sync-dev (>= 1.10~),
               libxcb-util-dev,
               libxcb-xfixes0-dev (>= 1.10~),
               libxcb-xtest0-dev,
               libxcb1-dev (>= 1.10~),
               libxcursor-dev,
               libxi-dev,
               libxkbcommon-dev (>= 0.7.0~),
               pkg-config,
               pkg-kde-tools (>= 0.15.18~),
               qtbase5-dev (>= 5.9.0~),
               qtbase5-private-dev (>= 5.7.0~),
               qtdeclarative5-dev (>= 5.9.0~),
               qtscript5-dev (>= 5.9.0~),
               qttools5-dev (>= 5.9.0~),
Standards-Version: 4.1.4
Homepage: https://projects.kde.org/projects/kde/workspace/kwin
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kwin
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kwin

Package: kde-window-manager
Architecture: all
Section: oldlibs
Priority: optional
Depends: kwin-x11 (>= 4:5.3.2-4~), ${misc:Depends}
Description: transitional package for kwin-x11
 This transitional package allows one to migrate to the packages providing
 the X11 version of the KDE window manager.
 .
 It can be safely removed after the installation.

Package: kwin
Architecture: all
Multi-Arch: no
Section: oldlibs
Priority: optional
Depends: kwin-x11, ${misc:Depends}
Description: Transitional dummy for kwin-x11
 This package is a transitional dummy to depend on the renamed kwin-x11 and
 can be removed.

Package: kwin-common
Architecture: any
Depends: kwin-data (= ${source:Version}),
         libkf5globalaccel-bin,
         libkwineffects12 (= ${binary:Version}),
         qml-module-org-kde-kirigami2 (>= 5.54.0~),
         qml-module-org-kde-kquickcontrolsaddons,
         qml-module-qtmultimedia,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libqt5multimedia5-plugins, plasma-desktop (>= 4:5.14), qtvirtualkeyboard-plugin
Suggests: kwin-addons (>= 4:5.14)
Breaks: kwin (<= 4:5.3.1-0ubuntu3),
Replaces: kwin (<= 4:5.3.1-0ubuntu3)
Description: KDE window manager, common files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.

Package: kwin-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: plasma-framework,
            qml-module-qtmultimedia,
            qml-module-qtquick-controls,
            qml-module-qtquick-layouts,
            qml-module-qtquick-virtualkeyboard,
            qml-module-qtquick-window2,
            qml-module-qtquick2,
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: KDE window manager data files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package contains the data files

Package: kwin-dev
Section: libdevel
Architecture: any
Depends: kwin-common (= ${binary:Version}),
         libegl1-mesa-dev (>= 1.2~),
         libepoxy-dev (>= 1.2),
         libkf5config-dev (>= 5.58.0~),
         libkf5coreaddons-dev (>= 5.58.0~),
         libkf5windowsystem-dev (>= 5.58.0~),
         libqt5x11extras5-dev (>= 5.9.0~),
         qtbase5-dev (>= 5.9.0~),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: kde-workspace-dev
Replaces: kde-workspace-dev
Description: KDE window manager - devel files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.

Package: kwin-wayland
Architecture: any
Depends: kwayland-integration (>= 5.14),
         kwin-common (= ${binary:Version}),
         kwin-wayland-backend-drm (= ${binary:Version}) | kwin-wayland-backend-fbdev (= ${binary:Version}) | kwin-wayland-backend-x11 (= ${binary:Version}) | kwin-wayland-backend-virtual (= ${binary:Version}) | kwin-wayland-backend-wayland (= ${binary:Version}),
         libcap2-bin [linux-any],
         xwayland,
         ${misc:Depends},
         ${shlibs:Depends},
Provides: kwin
Description: KDE window manager, wayland version, PREVIEW release
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package provides the wayland version, which is still a work in progress
 project, and is available as a PREVIEW release. Don't expect the same
 stability as with the x11 version.

Package: kwin-wayland-backend-drm
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager drm plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-wayland-backend-fbdev
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager fbdev plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-wayland-backend-virtual
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager virtual plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This backend allows running kwin-wayland in headless mode, useful for testing,
 or in the Cloud.

Package: kwin-wayland-backend-wayland
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager nested wayland plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-wayland-backend-x11
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager x11 plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-x11
Architecture: any
Depends: kwin-common (= ${binary:Version}),
         libkwinglutils12 (= ${binary:Version}),
         libkwinxrenderutils12 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: kde-window-manager (<< 4:5)
Replaces: kde-window-manager (<< 4:5)
Provides: kwin, x-window-manager
Description: KDE window manager, X11 version
 KWin (pronounced as one syllable "kwin") is the window
